package com.rjconsultores.ventaboletos.web.gui.controladores.esquemaoperacional;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Row;
import org.zkoss.zul.Textbox;

import com.rjconsultores.ventaboletos.entidad.Conexion;
import com.rjconsultores.ventaboletos.entidad.ConexionConf;
import com.rjconsultores.ventaboletos.entidad.ConexionCtrl;
import com.rjconsultores.ventaboletos.service.ConexionConfService;
import com.rjconsultores.ventaboletos.service.ConexionCtrlService;
import com.rjconsultores.ventaboletos.service.ConexionService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;

@Controller("editarConexionConfController")
@Scope("prototype")
public class EditarConexionConfController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	@Autowired
	private ConexionConfService conexionConfService;
	@Autowired
	private ConexionService conexionService;
	@Autowired
	private ConexionCtrlService conexionCtrlService;
	private ConexionConf conexionConf;
	private ConexionCtrl conexionCtrl;

	private MyListbox conexionesEditarList;

	private Textbox txtConFixa1;
	private Textbox txtConFixa2;
	private Textbox txtConFixa3;
	private Textbox txtConFixa4;

	private Row row1;
	private Row row2;
	private Row row3;
	private Row row4;

	private List<Row> rows;
	private List<Textbox> textBoxes;

	private List<Conexion> conexionsGroup;

	public ConexionConf getConexionConf() {
		return conexionConf;
	}

	public void setConexionConf(ConexionConf conexionConf) {
		this.conexionConf = conexionConf;
	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);
		textBoxes = new ArrayList<Textbox>();
		textBoxes.add(txtConFixa1);
		textBoxes.add(txtConFixa2);
		textBoxes.add(txtConFixa3);
		textBoxes.add(txtConFixa4);

		rows = new ArrayList<Row>();
		rows.add(row1);
		rows.add(row2);
		rows.add(row3);
		rows.add(row4);

		conexionConf = (ConexionConf) Executions.getCurrent().getArg().get("conexionConf");
		conexionesEditarList = (MyListbox) Executions.getCurrent().getArg().get("conexionesEditarList");
		conexionCtrl = (ConexionCtrl) Executions.getCurrent().getArg().get("conexionController");
		getServicosCorrida();
		setRowsVisible();
	}

	private void getServicosCorrida() {
		List<Conexion> conexions = conexionesEditarList.getListData();
		conexionsGroup = new ArrayList<Conexion>();
		for (Conexion conexion : conexions) {
			if (conexion.getNumgrupo() == conexionConf.getGrupo()) {
				conexionsGroup.add(conexion);
			}
		}

		Collections.sort(conexionsGroup, new Comparator<Conexion>() {
			@Override
			public int compare(Conexion con1, Conexion con2) {
				return con1.getNumsecuencia().compareTo(con2.getNumsecuencia());
			}
		});

		int i = 0;
		for (Conexion conToEdit : conexionsGroup) {
			textBoxes.get(i++).setText(conToEdit.getCorridaId() != null ? conToEdit.getCorridaId().toString() : "");
		}
	}

	private void setRowsVisible() {
		for (int i = 0; i < conexionsGroup.size(); i++) {
			rows.get(i).setVisible(true);
		}
	}

	public void onClick$btnDesativar(Event ev) throws Exception {
		int resp = Messagebox.show(
				Labels.getLabel("editarConexionController.MSG.borrarConexionDesativar"),
				Labels.getLabel("editarConexionController.window.title"),
				Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

		if (resp == Messagebox.YES) {
			conexionConf.setIndisponible(Boolean.TRUE);

			conexionConfService.actualizacion(conexionConf);

			conexionesEditarList.setData(conexionService.buscarPorConexionCtrl(conexionConf.getConexionCtrl().getConexionctrlId()));

			Messagebox.show(
					Labels.getLabel("editarConexionConfController.MSG.desativarOK"),
					Labels.getLabel("editarConexionConfController.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);

			closeWindow();
		}
	}

	public void onClick$btnAtivar(Event ev) throws Exception {
		int resp = Messagebox.show(
				Labels.getLabel("editarConexionController.MSG.borrarConexionAtivar"),
				Labels.getLabel("editarConexionController.window.title"),
				Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

		if (resp == Messagebox.YES) {
			conexionConf.setIndisponible(Boolean.FALSE);

			conexionConfService.actualizacion(conexionConf);

			conexionesEditarList.setData(conexionService.buscarPorConexionCtrl(conexionConf.getConexionCtrl().getConexionctrlId()));

			Messagebox.show(
					Labels.getLabel("editarConexionConfController.MSG.ativarOK"),
					Labels.getLabel("editarConexionConfController.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);

			closeWindow();
		}
	}

	public void onClick$btnSalvar(Event ev) throws Exception {
		conexionConfService.actualizacion(conexionConf);
		atualizarConexoes();

		Messagebox.show(
				Labels.getLabel("editarConexionConfController.MSG.suscribirOK"),
				Labels.getLabel("editarConexionConfController.window.title"),
				Messagebox.OK, Messagebox.INFORMATION);

		conexionesEditarList.setData(conexionService.buscarPorConexionCtrl(conexionConf.getConexionCtrl().getConexionctrlId()));

		closeWindow();
	}

	private void atualizarConexoes() {
		int i = 0;
		Boolean indFixa = false;
		for (Conexion conexion : conexionsGroup) {
			indFixa = indFixa || (textBoxes.get(i).getValue() != null && !textBoxes.get(i).getValue().isEmpty());
			conexion.setCorridaId(new Long(!textBoxes.get(i).getValue().isEmpty() ? textBoxes.get(i++).getValue() : "0"));
			conexionService.actualizacion(conexion);
		}

		conexionCtrl.setIndfixa(indFixa ? 1 : 0);
		conexionCtrlService.actualizacion(conexionCtrl);
	}
}
